Subject: Re: crypto: p10-aes-gcm - Add asm markings necessary for kernel code

From: Sathvika Vasireddy <[email-masked]>
Date: Wed, 18 Jan 2023 14:13:58 +0530

Hi Stephen,

On 18/01/23 08:34, Stephen Rothwell wrote:
> Hi Herbert,
>
> On Tue, 17 Jan 2023 15:26:24 +0800 Herbert Xu <[email-masked]> wrote:
>> On Tue, Jan 17, 2023 at 02:47:47PM +1100, Stephen Rothwell wrote:
>>> Hi all,
>>>
>>> After merging the crypto tree, today's linux-next build (powerpc
>>> pseries_le_defconfig) failed like this:
>>>
>>> arch/powerpc/crypto/p10_aes_gcm.o: warning: objtool: .text+0x884: unannotated intra-function call
>>> arch/powerpc/crypto/aesp8-ppc.o: warning: objtool: aes_p8_set_encrypt_key+0x44: unannotated intra-function call
>>> ld: arch/powerpc/crypto/p10_aes_gcm.o: ABI version 1 is not compatible with ABI version 2 output
>>> ld: failed to merge target specific data of file arch/powerpc/crypto/p10_aes_gcm.o
>>>
>>> Caused by commit
>>>
>>>    ca68a96c37eb ("crypto: p10-aes-gcm - An accelerated AES/GCM stitched implementation")
>>>
>>> I have applied the following hack for today.
>> Thanks Stephen, I'm going to update the previous fix as follows:
> I still get:
>
> arch/powerpc/crypto/aesp8-ppc.o: warning: objtool: aes_p8_set_encrypt_key+0x44: unannotated intra-function call
>
> from the powerpc pseries_le_defconfig build (which is otherwise ok).

Warnings [1], [2], and [3] are seen with pseries_le_defconfig.

[1] - arch/powerpc/crypto/aesp8-ppc.o: warning: objtool: aes_p8_set_encrypt_key+0x44: unannotated intra-function call
[2] - arch/powerpc/crypto/aesp8-ppc.o: warning: objtool: .text+0x2448: unannotated intra-function call
[3] - arch/powerpc/crypto/aesp8-ppc.o: warning: objtool: .text+0x2d68: unannotated intra-function call

Given that there are no calls to _mcount, one way to address this warning, is by skipping objtool from running on arch/powerpc/crypto/aesp8-ppc.o file.
The below diff works for me.

=====
diff --git a/arch/powerpc/crypto/Makefile b/arch/powerpc/crypto/Makefile
index 5b8252013abd..d00664c8d761 100644
--- a/arch/powerpc/crypto/Makefile
+++ b/arch/powerpc/crypto/Makefile
@@ -31,3 +31,5 @@ targets += aesp8-ppc.S ghashp8-ppc.S
  
  $(obj)/aesp8-ppc.S $(obj)/ghashp8-ppc.S: $(obj)/%.S: $(src)/%.pl FORCE
         $(call if_changed,perl)
+
+OBJECT_FILES_NON_STANDARD_aesp8-ppc.o := y
=====

The other way to fix these warnings is by using ANNOTATE_INTRA_FUNCTION_CALL macro to indicate that the branch target is valid. And, by annotating symbols with SYM_FUNC_START_LOCAL and SYM_FUNC_END macros.
The below diff works for me:

=====
diff --git a/arch/powerpc/crypto/aesp8-ppc.pl b/arch/powerpc/crypto/aesp8-ppc.pl
index cdbcf6e13efc..355e0036869a 100644
--- a/arch/powerpc/crypto/aesp8-ppc.pl
+++ b/arch/powerpc/crypto/aesp8-ppc.pl
@@ -80,6 +80,9 @@
  # POWER8[le]   3.96/0.72       0.74    1.1
  # POWER8[be]   3.75/0.65       0.66    1.0
  
+print "#include <linux/objtool.h>\n";
+print "#include <linux/linkage.h>\n";
+
  $flavour = shift;
  
  if ($flavour =~ /64/) {
@@ -185,7 +188,8 @@ Lset_encrypt_key:
         lis             r0,0xfff0
         mfspr           $vrsave,256
         mtspr           256,r0
-
+
+       ANNOTATE_INTRA_FUNCTION_CALL
         bl              Lconsts
         mtlr            r11
  
@@ -3039,7 +3043,7 @@ Lxts_enc6x_ret:
         .long           0
  
  .align 5
-_aesp8_xts_enc5x:
+SYM_FUNC_START_LOCAL(_aesp8_xts_enc5x)
         vcipher         $out0,$out0,v24
         vcipher         $out1,$out1,v24
         vcipher         $out2,$out2,v24
@@ -3121,6 +3125,7 @@ _aesp8_xts_enc5x:
         blr
          .long          0
          .byte          0,12,0x14,0,0,0,0,0
+SYM_FUNC_END(_aesp8_xts_enc5x)
  
  .align 5
  _aesp8_xts_decrypt6x:
@@ -3727,7 +3732,7 @@ Lxts_dec6x_ret:
         .long           0
  
  .align 5
-_aesp8_xts_dec5x:
+SYM_FUNC_START_LOCAL(_aesp8_xts_dec5x)
         vncipher        $out0,$out0,v24
         vncipher        $out1,$out1,v24
         vncipher        $out2,$out2,v24
@@ -3809,6 +3814,7 @@ _aesp8_xts_dec5x:
         blr
          .long          0
          .byte          0,12,0x14,0,0,0,0,0
+SYM_FUNC_END(_aesp8_xts_dec5x)
  ___
  }}     }}}

=====

Thanks,
Sathvika